Index: trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc	(revision 1231)
@@ -493,223 +541,236 @@
 
 {
-      // G4double errpos_rel_sq, errvel_rel_sq
-      G4double errmax_sq;
-      // G4double errmax; 
-      G4double h, htemp, xnew ;
-
-      G4double yerr[G4FieldTrack::ncompSVEC], ytemp[G4FieldTrack::ncompSVEC];
-
-      h = htry ; // Set stepsize to the initial trial value
-
-      // G4double inv_epspos_sq = 1.0 / eps * eps; 
-      G4double inv_eps_vel_sq = 1.0 / (eps_rel_max*eps_rel_max); 
-
-      G4double errpos_sq=0.0;    // square of displacement error
-      G4double errvel_sq=0.0;    // square of momentum vector difference
-
-      G4int iter;
-
-      static G4int tot_no_trials=0; 
-      const G4int max_trials=100; 
-
-      for (iter=0; iter<max_trials ;iter++)
-      {
-	  tot_no_trials++;
-	  pIntStepper-> Stepper(y,dydx,h,ytemp,yerr); 
-          //            *******
-          G4double eps_pos = eps_rel_max * std::max(h, fMinimumStep); 
-	  G4double inv_eps_pos_sq = 1.0 / (eps_pos*eps_pos); 
-
-	  // Evaluate accuracy
-	  //
-	  errpos_sq =  sqr(yerr[0]) + sqr(yerr[1]) + sqr(yerr[2]) ;
-	  // errpos_sq /= eps_pos*eps_pos; // Scale to tolerance
-	  errpos_sq *= inv_eps_pos_sq; // Scale relative to required tolerance
-
-          // Accuracy for momentum
-          errvel_sq =  (sqr(yerr[3]) + sqr(yerr[4]) + sqr(yerr[5]) )
-                     / (sqr(y[3]) + sqr(y[4]) + sqr(y[5]) );
-          // errvel_sq /= eps_rel_max*eps_rel_max; 
-          errvel_sq *= inv_eps_vel_sq;
-
-          errmax_sq = std::max( errpos_sq, errvel_sq ); // Square of maximum error
-          // errmax = std::sqrt( errmax_sq );
-	  if(errmax_sq <= 1.0 ) break ; // Step succeeded. 
-
-	  // Step failed; compute the size of retrial Step.
-	  htemp = GetSafety()*h* std::pow( errmax_sq, 0.5*GetPshrnk() );
-
-	  if(htemp >= 0.1*h) h = htemp ;  // Truncation error too large,
-	  else h = 0.1*h ;                // reduce stepsize, but no more
-					  // than a factor of 10
-	  xnew = x + h ;
-	  if(xnew == x) {
-	     G4cerr<<"G4MagIntegratorDriver::OneGoodStep: Stepsize underflow in Stepper "<<G4endl ;
-	     G4cerr<<"  Step's start x=" << x << " and end x= " << xnew 
-		   << " are equal !! " << G4endl
-		   <<"  Due to step-size= " << h 
-                   << " . Note that input step was " << htry << G4endl;
-	     break;
-	  }
-      }
-      // tot_no_trials+= (iter+1); 
+  G4double errmax_sq;
+  G4double h, htemp, xnew ;
+
+  G4double yerr[G4FieldTrack::ncompSVEC], ytemp[G4FieldTrack::ncompSVEC];
+
+  h = htry ; // Set stepsize to the initial trial value
+
+  G4double inv_eps_vel_sq = 1.0 / (eps_rel_max*eps_rel_max);
+
+  G4double errpos_sq=0.0;    // square of displacement error
+  G4double errvel_sq=0.0;    // square of momentum vector difference
+  G4double errspin_sq=0.0;   // square of spin vector difference
+
+  G4int iter;
+
+  static G4int tot_no_trials=0; 
+  const G4int max_trials=100; 
+
+  G4ThreeVector Spin(y[9],y[10],y[11]);
+  G4bool     hasSpin= (Spin.mag2() > 0.0); 
+
+  for (iter=0; iter<max_trials ;iter++)
+  {
+    tot_no_trials++;
+    pIntStepper-> Stepper(y,dydx,h,ytemp,yerr); 
+    //            *******
+    G4double eps_pos = eps_rel_max * std::max(h, fMinimumStep); 
+    G4double inv_eps_pos_sq = 1.0 / (eps_pos*eps_pos); 
+
+    // Evaluate accuracy
+    //
+    errpos_sq =  sqr(yerr[0]) + sqr(yerr[1]) + sqr(yerr[2]) ;
+    errpos_sq *= inv_eps_pos_sq; // Scale relative to required tolerance
+
+    // Accuracy for momentum
+    errvel_sq =  (sqr(yerr[3]) + sqr(yerr[4]) + sqr(yerr[5]) )
+               / (sqr(y[3]) + sqr(y[4]) + sqr(y[5]) );
+    errvel_sq *= inv_eps_vel_sq;
+    errmax_sq = std::max( errpos_sq, errvel_sq ); // Square of maximum error
+
+    if( hasSpin )
+    { 
+      // Accuracy for spin
+      errspin_sq =  ( sqr(yerr[9]) + sqr(yerr[10]) + sqr(yerr[11]) )
+                 /  ( sqr(y[9]) + sqr(y[10]) + sqr(y[11]) );
+      errspin_sq *= inv_eps_vel_sq;
+      errmax_sq = std::max( errmax_sq, errspin_sq ); 
+   }
+
+    if ( errmax_sq <= 1.0 )  { break; } // Step succeeded. 
+
+    // Step failed; compute the size of retrial Step.
+    htemp = GetSafety()*h* std::pow( errmax_sq, 0.5*GetPshrnk() );
+
+    if (htemp >= 0.1*h)  { h = htemp; }  // Truncation error too large,
+    else  { h = 0.1*h; }                 // reduce stepsize, but no more
+                                         // than a factor of 10
+    xnew = x + h;
+    if(xnew == x)
+    {
+      G4cerr << "G4MagIntegratorDriver::OneGoodStep:" << G4endl
+             << "  Stepsize underflow in Stepper " << G4endl ;
+      G4cerr << "  Step's start x=" << x << " and end x= " << xnew 
+             << " are equal !! " << G4endl
+             <<"  Due to step-size= " << h 
+             << " . Note that input step was " << htry << G4endl;
+      break;
+    }
+  }
 
 #ifdef G4FLD_STATS
-      // Sum of squares of position error // and momentum dir (underestimated)
-      fSumH_lg += h; 
-      fDyerrPos_lgTot += errpos_sq;  //  + errvel_last_sq * h * h ; 
-      fDyerrVel_lgTot += errvel_sq * h * h; 
-#endif
-
-      // Compute size of next Step
-      if(errmax_sq > errcon*errcon) 
-               hnext = GetSafety()*h*std::pow(errmax_sq, 0.5*GetPgrow()) ;
-      else hnext = max_stepping_increase*h ;
-                     // No more than a factor of 5 increase
-
-      x += (hdid = h) ;
-
-      int i;
-      const int nvar= fNoIntegrationVariables;   
-      for(i=0;i<nvar;i++) y[i] = ytemp[i] ;
-
-      return ;
-
+  // Sum of squares of position error // and momentum dir (underestimated)
+  fSumH_lg += h; 
+  fDyerrPos_lgTot += errpos_sq;
+  fDyerrVel_lgTot += errvel_sq * h * h; 
+#endif
+
+  // Compute size of next Step
+  if (errmax_sq > errcon*errcon)
+  { 
+    hnext = GetSafety()*h*std::pow(errmax_sq, 0.5*GetPgrow());
+  }
+  else
+  {
+    hnext = max_stepping_increase*h ; // No more than a factor of 5 increase
+  }
+  x += (hdid = h);
+
+  for(G4int k=0;k<fNoIntegrationVariables;k++) { y[k] = ytemp[k]; }
+
+  return;
 }   // end of  OneGoodStep .............................
 
 //----------------------------------------------------------------------
+
 // QuickAdvance just tries one Step - it does not ensure accuracy
 //
 G4bool  G4MagInt_Driver::QuickAdvance(       
-			    G4FieldTrack& y_posvel,         // INOUT
-		            const G4double     dydx[],  
-		                  G4double     hstep,       // In
-			          G4double&    dchord_step,
-   			          G4double&    dyerr_pos_sq,
-			          G4double&    dyerr_mom_rel_sq
-			    //    G4double&    dyerr_ener_sq // Future
- )  
-{
-      G4Exception("G4MagInt_Driver::QuickAdvance()", "NotImplemented",
-                  FatalException, "Not yet implemented."); 
-
-      // Use the parameters of this method, to please compiler
-      dchord_step = dyerr_pos_sq = hstep * hstep * dydx[0]; 
-      dyerr_mom_rel_sq = y_posvel.GetPosition().mag2();
-      return true;
-}
+                            G4FieldTrack& y_posvel,         // INOUT
+                            const G4double     dydx[],  
+                                  G4double     hstep,       // In
+                                  G4double&    dchord_step,
+                                  G4double&    dyerr_pos_sq,
+                                  G4double&    dyerr_mom_rel_sq )  
+{
+  G4Exception("G4MagInt_Driver::QuickAdvance()", "NotImplemented",
+              FatalException, "Not yet implemented."); 
+
+  // Use the parameters of this method, to please compiler
+  dchord_step = dyerr_pos_sq = hstep * hstep * dydx[0]; 
+  dyerr_mom_rel_sq = y_posvel.GetPosition().mag2();
+  return true;
+}
+
+//----------------------------------------------------------------------
 
 G4bool  G4MagInt_Driver::QuickAdvance(       
-			    G4FieldTrack& y_posvel,         // INOUT
-		            const G4double     dydx[],  
-		                  G4double     hstep,       // In
-			          G4double&    dchord_step,
-			          G4double&    dyerr )
-{
-    G4double   dyerr_pos_sq,  dyerr_mom_rel_sq;  
-    G4double yerr_vec[G4FieldTrack::ncompSVEC], yarrin[G4FieldTrack::ncompSVEC], yarrout[G4FieldTrack::ncompSVEC]; 
-    G4double s_start;
-    // G4double dyerr_len=0.0;  // , dyerr_vel, vel_mag;
-    G4double dyerr_mom_sq, vel_mag_sq, inv_vel_mag_sq;
-
-    static G4int no_call=0; 
-    no_call ++; 
-
-    // Move data into array
-    y_posvel.DumpToArray( yarrin );      //  yarrin  <== y_posvel 
-    s_start = y_posvel.GetCurveLength();
-
-    // Do an Integration Step
-    pIntStepper-> Stepper(yarrin, dydx, hstep, yarrout, yerr_vec) ; 
-    //            *******
-
-    // Estimate curve-chord distance
-    dchord_step= pIntStepper-> DistChord();
-    //                         *********
-
-    // Put back the values.
-    y_posvel.LoadFromArray( yarrout, fNoIntegrationVariables );   //  yarrout ==> y_posvel
-    y_posvel.SetCurveLength( s_start + hstep );
+                            G4FieldTrack& y_posvel,         // INOUT
+                            const G4double     dydx[],  
+                                  G4double     hstep,       // In
+                                  G4double&    dchord_step,
+                                  G4double&    dyerr )
+{
+  G4double dyerr_pos_sq, dyerr_mom_rel_sq;  
+  G4double yerr_vec[G4FieldTrack::ncompSVEC],
+           yarrin[G4FieldTrack::ncompSVEC], yarrout[G4FieldTrack::ncompSVEC]; 
+  G4double s_start;
+  G4double dyerr_mom_sq, vel_mag_sq, inv_vel_mag_sq;
+
+  static G4int no_call=0; 
+  no_call ++; 
+
+  // Move data into array
+  y_posvel.DumpToArray( yarrin );      //  yarrin  <== y_posvel 
+  s_start = y_posvel.GetCurveLength();
+
+  // Do an Integration Step
+  pIntStepper-> Stepper(yarrin, dydx, hstep, yarrout, yerr_vec) ; 
+  //            *******
+
+  // Estimate curve-chord distance
+  dchord_step= pIntStepper-> DistChord();
+  //                         *********
+
+  // Put back the values.  yarrout ==> y_posvel
+  y_posvel.LoadFromArray( yarrout, fNoIntegrationVariables );
+  y_posvel.SetCurveLength( s_start + hstep );
 
 #ifdef  G4DEBUG_FIELD
-    if(fVerboseLevel>2) {
-       G4cout << "G4MagIntDrv: Quick Advance" << G4endl;
-       PrintStatus( yarrin, s_start, yarrout, s_start+hstep, hstep,  1); 
-    }
-#endif
-
-    // A single measure of the error   
-    //      TO-DO :  account for  energy,  spin, ... ? 
-    vel_mag_sq   = ( sqr(yarrout[3])+sqr(yarrout[4])+sqr(yarrout[5]) );
-    inv_vel_mag_sq = 1.0 / vel_mag_sq; 
-    dyerr_pos_sq = ( sqr(yerr_vec[0])+sqr(yerr_vec[1])+sqr(yerr_vec[2]));
-    dyerr_mom_sq = ( sqr(yerr_vec[3])+sqr(yerr_vec[4])+sqr(yerr_vec[5]));
-
-    dyerr_mom_rel_sq =  dyerr_mom_sq * inv_vel_mag_sq;
-
-    //// Calculate also the change in the momentum squared also ???
-    // G4double veloc_square = y_posvel.GetVelocity().mag2();
-    // ...
+  if(fVerboseLevel>2)
+  {
+    G4cout << "G4MagIntDrv: Quick Advance" << G4endl;
+    PrintStatus( yarrin, s_start, yarrout, s_start+hstep, hstep,  1); 
+  }
+#endif
+
+  // A single measure of the error   
+  //      TO-DO :  account for  energy,  spin, ... ? 
+  vel_mag_sq   = ( sqr(yarrout[3])+sqr(yarrout[4])+sqr(yarrout[5]) );
+  inv_vel_mag_sq = 1.0 / vel_mag_sq; 
+  dyerr_pos_sq = ( sqr(yerr_vec[0])+sqr(yerr_vec[1])+sqr(yerr_vec[2]));
+  dyerr_mom_sq = ( sqr(yerr_vec[3])+sqr(yerr_vec[4])+sqr(yerr_vec[5]));
+  dyerr_mom_rel_sq = dyerr_mom_sq * inv_vel_mag_sq;
+
+  // Calculate also the change in the momentum squared also ???
+  // G4double veloc_square = y_posvel.GetVelocity().mag2();
+  // ...
 
 #ifdef RETURN_A_NEW_STEP_LENGTH
-    // The following step cannot be done here because "eps" is not known.
-    dyerr_len = std::sqrt( dyerr_len_sq ); 
-    dyerr_len_sq /= eps ;
-
-    // Look at the velocity deviation ?
-    //  sqr(yerr_vec[3])+sqr(yerr_vec[4])+sqr(yerr_vec[5]));
-
-   // Set suggested new step
-    hstep= ComputeNewStepSize( dyerr_len, hstep);
-#endif
-
-    if( dyerr_pos_sq > ( dyerr_mom_rel_sq * sqr(hstep) ) ) {
-       dyerr = std::sqrt(dyerr_pos_sq);
-    }else{
-       // Scale it to the current step size - for now
-       dyerr = std::sqrt(dyerr_mom_rel_sq) * hstep;
-    }
-
-    return true;
-}
+  // The following step cannot be done here because "eps" is not known.
+  dyerr_len = std::sqrt( dyerr_len_sq ); 
+  dyerr_len_sq /= eps ;
+
+  // Look at the velocity deviation ?
+  //  sqr(yerr_vec[3])+sqr(yerr_vec[4])+sqr(yerr_vec[5]));
+
+  // Set suggested new step
+  hstep= ComputeNewStepSize( dyerr_len, hstep);
+#endif
+
+  if( dyerr_pos_sq > ( dyerr_mom_rel_sq * sqr(hstep) ) )
+  {
+    dyerr = std::sqrt(dyerr_pos_sq);
+  }
+  else
+  {
+    // Scale it to the current step size - for now
+    dyerr = std::sqrt(dyerr_mom_rel_sq) * hstep;
+  }
+
+  return true;
+}
+
+// --------------------------------------------------------------------------
 
 #ifdef QUICK_ADV_ARRAY_IN_AND_OUT
 G4bool  G4MagInt_Driver::QuickAdvance(       
-				  G4double     yarrin[],        // IN
-		            const G4double     dydx[],  
-		                  G4double     hstep,       // In
-				  G4double     yarrout[],
-			          G4double&    dchord_step,
-			          G4double&    dyerr )      // in length
-{
-   G4Exception("G4MagInt_Driver::QuickAdvance()", "NotImplemented",
-                FatalException, "Not yet implemented.");
-
-   dyerr = dchord_step = hstep * yarrin[0] * dydx[0];
-   yarrout[0]= yarrin[0];
+                                  G4double     yarrin[],    // In
+                            const G4double     dydx[],  
+                                  G4double     hstep,       // In
+                                  G4double     yarrout[],
+                                  G4double&    dchord_step,
+                                  G4double&    dyerr )      // In length
+{
+  G4Exception("G4MagInt_Driver::QuickAdvance()", "NotImplemented",
+              FatalException, "Not yet implemented.");
+  dyerr = dchord_step = hstep * yarrin[0] * dydx[0];
+  yarrout[0]= yarrin[0];
 }
 #endif 
 
 // --------------------------------------------------------------------------
+
 //  This method computes new step sizes - but does not limit changes to
 //   within  certain factors
 // 
-
 G4double 
 G4MagInt_Driver::ComputeNewStepSize( 
                           G4double  errMaxNorm,    // max error  (normalised)
-			  G4double  hstepCurrent)  // current step size
+                          G4double  hstepCurrent)  // current step size
 {
   G4double hnew;
 
   // Compute size of next Step for a failed step
-  if(errMaxNorm > 1.0 ) {
-
+  if(errMaxNorm > 1.0 )
+  {
     // Step failed; compute the size of retrial Step.
     hnew = GetSafety()*hstepCurrent*std::pow(errMaxNorm,GetPshrnk()) ;
-  }else if(errMaxNorm > 0.0 ){
+  } else if(errMaxNorm > 0.0 ) {
     // Compute size of next Step for a successful step
     hnew = GetSafety()*hstepCurrent*std::pow(errMaxNorm,GetPgrow()) ;
-  }else {
+  } else {
     // if error estimate is zero (possible) or negative (dubious)
     hnew = max_stepping_increase * hstepCurrent; 
@@ -719,45 +780,50 @@
 }
 
-// -----------------------------------------------------------------------------
-//  This method computes new step sizes limiting changes within certain factors
+// ---------------------------------------------------------------------------
+
+// This method computes new step sizes limiting changes within certain factors
 // 
-//   It shares its logic with AccurateAdvance.
-//    They are kept separate currently for optimisation.
-
+// It shares its logic with AccurateAdvance.
+// They are kept separate currently for optimisation.
+//
 G4double 
 G4MagInt_Driver::ComputeNewStepSize_WithinLimits( 
                           G4double  errMaxNorm,    // max error  (normalised)
-			  G4double  hstepCurrent)  // current step size
+                          G4double  hstepCurrent)  // current step size
 {
   G4double hnew;
 
   // Compute size of next Step for a failed step
-  if(errMaxNorm > 1.0 ) {
-
+  if (errMaxNorm > 1.0 )
+  {
     // Step failed; compute the size of retrial Step.
     hnew = GetSafety()*hstepCurrent*std::pow(errMaxNorm,GetPshrnk()) ;
   
-    if(hnew < max_stepping_decrease*hstepCurrent) 
-         hnew = max_stepping_decrease*hstepCurrent ;
+    if (hnew < max_stepping_decrease*hstepCurrent)
+    {
+      hnew = max_stepping_decrease*hstepCurrent ;
                          // reduce stepsize, but no more
                          // than this factor (value= 1/10)
-  }else{
+    }
+  }
+  else
+  {
     // Compute size of next Step for a successful step
-    if(errMaxNorm > errcon) hnew = GetSafety()*hstepCurrent*std::pow(errMaxNorm,GetPgrow()) ;
-    else                    hnew = max_stepping_increase * hstepCurrent ;
-      // No more than a factor of 5 increase
-  }
-
+    if (errMaxNorm > errcon)
+     { hnew = GetSafety()*hstepCurrent*std::pow(errMaxNorm,GetPgrow()); }
+    else  // No more than a factor of 5 increase
+     { hnew = max_stepping_increase * hstepCurrent; }
+  }
   return hnew;
 }
 
-
+// ---------------------------------------------------------------------------
 
 void G4MagInt_Driver::PrintStatus( const G4double*   StartArr,  
-				   G4double          xstart,
-				   const G4double*   CurrentArr, 
-				   G4double          xcurrent,
-				   G4double          requestStep, 
-				   G4int             subStepNo)
+                                   G4double          xstart,
+                                   const G4double*   CurrentArr, 
+                                   G4double          xcurrent,
+                                   G4double          requestStep, 
+                                   G4int             subStepNo)
   // Potentially add as arguments:  
   //                                 <dydx>           - as Initial Force
@@ -765,5 +831,6 @@
   //                                 nextStep (hnext) - proposal for size
 {
-   G4FieldTrack  StartFT(G4ThreeVector(0,0,0), G4ThreeVector(0,0,0), 0., 0., 0., 0. );
+   G4FieldTrack  StartFT(G4ThreeVector(0,0,0),
+                 G4ThreeVector(0,0,0), 0., 0., 0., 0. );
    G4FieldTrack  CurrentFT (StartFT);
 
@@ -776,11 +843,10 @@
 }
 
-
+// ---------------------------------------------------------------------------
 
 void G4MagInt_Driver::PrintStatus(
                   const G4FieldTrack&  StartFT,
-		  const G4FieldTrack&  CurrentFT, 
+                  const G4FieldTrack&  CurrentFT, 
                   G4double             requestStep, 
-                  // G4double             safety,
                   G4int                subStepNo)
 {
@@ -790,16 +856,13 @@
     // G4cout.setf(ios_base::fixed,ios_base::floatfield);
 
-    const G4ThreeVector StartPosition=      StartFT.GetPosition();
-    const G4ThreeVector StartUnitVelocity=  StartFT.GetMomentumDir();
-    const G4ThreeVector CurrentPosition=    CurrentFT.GetPosition();
-    const G4ThreeVector CurrentUnitVelocity=    CurrentFT.GetMomentumDir();
+    const G4ThreeVector StartPosition=       StartFT.GetPosition();
+    const G4ThreeVector StartUnitVelocity=   StartFT.GetMomentumDir();
+    const G4ThreeVector CurrentPosition=     CurrentFT.GetPosition();
+    const G4ThreeVector CurrentUnitVelocity= CurrentFT.GetMomentumDir();
 
     G4double  DotStartCurrentVeloc= StartUnitVelocity.dot(CurrentUnitVelocity);
 
-    G4double step_len= CurrentFT.GetCurveLength() 
-                         - StartFT.GetCurveLength();
+    G4double step_len= CurrentFT.GetCurveLength() - StartFT.GetCurveLength();
     G4double subStepSize = step_len;
-
-    // G4cout << " G4MagInt_Driver: Current Position  and  Direction" << G4endl;
      
     if( (subStepNo <= 1) || (verboseLevel > 3) )
@@ -807,37 +870,38 @@
        subStepNo = - subStepNo;        // To allow printing banner
 
-       G4cout << std::setw( 6)  << " " 
-	      << std::setw( 25) << " G4MagInt_Driver: Current Position  and  Direction" << " "
-	      << G4endl; 
+       G4cout << std::setw( 6)  << " " << std::setw( 25)
+              << " G4MagInt_Driver: Current Position  and  Direction" << " "
+              << G4endl; 
        G4cout << std::setw( 5) << "Step#" << " "
-	      << std::setw( 7) << "s-curve" << " "
-	      << std::setw( 9) << "X(mm)" << " "
-	      << std::setw( 9) << "Y(mm)" << " "  
-	      << std::setw( 9) << "Z(mm)" << " "
-	      << std::setw( 8) << " N_x " << " "
-	      << std::setw( 8) << " N_y " << " "
-	      << std::setw( 8) << " N_z " << " "
-	      << std::setw( 8) << " N^2-1 " << " "
-	      << std::setw(10) << " N(0).N " << " "
-	      << std::setw( 7) << "KinEner " << " "
-	      << std::setw(12) << "Track-l" << " "   // Add the Sub-step ??
-	      << std::setw(12) << "Step-len" << " " 
-	      << std::setw(12) << "Step-len" << " " 
-	      << std::setw( 9) << "ReqStep" << " "  
-	      << G4endl;
-    }
-
-    if( (subStepNo <= 0) ){
-       PrintStat_Aux( StartFT,  requestStep, 0., 
-		       0,        0.0,         1.0);
-        //*************
+              << std::setw( 7) << "s-curve" << " "
+              << std::setw( 9) << "X(mm)" << " "
+              << std::setw( 9) << "Y(mm)" << " "  
+              << std::setw( 9) << "Z(mm)" << " "
+              << std::setw( 8) << " N_x " << " "
+              << std::setw( 8) << " N_y " << " "
+              << std::setw( 8) << " N_z " << " "
+              << std::setw( 8) << " N^2-1 " << " "
+              << std::setw(10) << " N(0).N " << " "
+              << std::setw( 7) << "KinEner " << " "
+              << std::setw(12) << "Track-l" << " "   // Add the Sub-step ??
+              << std::setw(12) << "Step-len" << " " 
+              << std::setw(12) << "Step-len" << " " 
+              << std::setw( 9) << "ReqStep" << " "  
+              << G4endl;
+    }
+
+    if( (subStepNo <= 0) )
+    {
+      PrintStat_Aux( StartFT,  requestStep, 0., 
+                       0,        0.0,         1.0);
+      //*************
     }
 
     if( verboseLevel <= 3 )
     {
-       G4cout.precision(noPrecision);
-       PrintStat_Aux( CurrentFT, requestStep, step_len, 
-		      subStepNo, subStepSize, DotStartCurrentVeloc );
-       //*************
+      G4cout.precision(noPrecision);
+      PrintStat_Aux( CurrentFT, requestStep, step_len, 
+                     subStepNo, subStepSize, DotStartCurrentVeloc );
+      //*************
     }
 
@@ -851,18 +915,19 @@
        //    << " out of PhysicalStep= " <<  requestStep << G4endl;
        // G4cout << "Final safety is: " << safety << G4endl;
-
-       // G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag() << G4endl;
-       // G4cout << G4endl; 
+       // G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag()
+       //        << G4endl << G4endl; 
     }
     G4cout.precision(oldPrec);
 }
+
+// ---------------------------------------------------------------------------
 
 void G4MagInt_Driver::PrintStat_Aux(
                   const G4FieldTrack&  aFieldTrack,
                   G4double             requestStep, 
-		  G4double             step_len,
+                  G4double             step_len,
                   G4int                subStepNo,
-		  G4double             subStepSize,
-		  G4double             dotVeloc_StartCurr)
+                  G4double             subStepSize,
+                  G4double             dotVeloc_StartCurr)
 {
     const G4ThreeVector Position=      aFieldTrack.GetPosition();
@@ -870,15 +935,19 @@
  
     if( subStepNo >= 0)
+    {
        G4cout << std::setw( 5) << subStepNo << " ";
+    }
     else
+    {
        G4cout << std::setw( 5) << "Start" << " ";
+    }
     G4double curveLen= aFieldTrack.GetCurveLength();
     G4cout << std::setw( 7) << curveLen;
     G4cout << std::setw( 9) << Position.x() << " "
-	   << std::setw( 9) << Position.y() << " "
-	   << std::setw( 9) << Position.z() << " "
-	   << std::setw( 8) << UnitVelocity.x() << " "
-	   << std::setw( 8) << UnitVelocity.y() << " "
-	   << std::setw( 8) << UnitVelocity.z() << " ";
+           << std::setw( 9) << Position.y() << " "
+           << std::setw( 9) << Position.z() << " "
+           << std::setw( 8) << UnitVelocity.x() << " "
+           << std::setw( 8) << UnitVelocity.y() << " "
+           << std::setw( 8) << UnitVelocity.z() << " ";
     G4int oldprec= G4cout.precision(3);
     G4cout << std::setw( 8) << UnitVelocity.mag2()-1.0 << " ";
@@ -891,12 +960,15 @@
     static G4double oldCurveLength= 0.0;
     static G4double oldSubStepLength= 0.0;
-    static int oldSubStepNo= -1;
+    static G4int oldSubStepNo= -1;
 
     G4double subStep_len=0.0;
     if( curveLen > oldCurveLength )
-       subStep_len= curveLen - oldCurveLength;
+    {
+      subStep_len= curveLen - oldCurveLength;
+    }
     else if (subStepNo == oldSubStepNo)
-       subStep_len= oldSubStepLength;
-    //     else  subStepLen_NotAvail;
+    {
+      subStep_len= oldSubStepLength;
+    }
     oldCurveLength= curveLen;
     oldSubStepLength= subStep_len;
@@ -904,11 +976,16 @@
     G4cout << std::setw(12) << subStep_len << " "; 
     G4cout << std::setw(12) << subStepSize << " "; 
-    if( requestStep != -1.0 ) 
-       G4cout << std::setw( 9) << requestStep << " ";
+    if( requestStep != -1.0 )
+    {
+      G4cout << std::setw( 9) << requestStep << " ";
+    }
     else
-       G4cout << std::setw( 9) << " InitialStep " << " "; 
-    // G4cout << std::setw(12) << safety << " ";
+    {
+       G4cout << std::setw( 9) << " InitialStep " << " ";
+    }
     G4cout << G4endl;
 }
+
+// ---------------------------------------------------------------------------
 
 void G4MagInt_Driver::PrintStatisticsReport()
@@ -919,20 +996,19 @@
   G4cout << "G4MagInt_Driver Statistics of steps undertaken. " << G4endl;
   G4cout << "G4MagInt_Driver: Number of Steps: "
-	 << " Total= " <<  fNoTotalSteps
+         << " Total= " <<  fNoTotalSteps
          << " Bad= "   <<  fNoBadSteps 
          << " Small= " <<  fNoSmallSteps 
-	 << " Non-initial small= " << (fNoSmallSteps-fNoInitialSmallSteps)
-	 << G4endl;
-
- #ifdef G4FLD_STATS
- G4cout << "MID dyerr: " 
-	 << " maximum= " << fDyerr_max 
-	 // << " 2nd max= " << fDyerr_mx2
-	 << " Sum small= " << fDyerrPos_smTot 
-	 << " std::sqrt(Sum large^2): pos= " << std::sqrt(fDyerrPos_lgTot)
-	 << " vel= " << std::sqrt( fDyerrVel_lgTot )
-	 << " Total h-distance: small= " << fSumH_sm 
-	 << " large= " << fSumH_lg
-	 << G4endl;
+         << " Non-initial small= " << (fNoSmallSteps-fNoInitialSmallSteps)
+         << G4endl;
+
+#ifdef G4FLD_STATS
+  G4cout << "MID dyerr: " 
+         << " maximum= " << fDyerr_max 
+         << " Sum small= " << fDyerrPos_smTot 
+         << " std::sqrt(Sum large^2): pos= " << std::sqrt(fDyerrPos_lgTot)
+         << " vel= " << std::sqrt( fDyerrVel_lgTot )
+         << " Total h-distance: small= " << fSumH_sm 
+         << " large= " << fSumH_lg
+         << G4endl;
 
 #if 0
@@ -941,30 +1017,35 @@
   G4cout.precision(noPrecSmall);
   G4cout << "MIDnums: " << fMinimumStep
-	 << "   " << fNoTotalSteps 
-	 << "  "  <<  fNoSmallSteps
+         << "   " << fNoTotalSteps 
+         << "  "  <<  fNoSmallSteps
          << "  "  << fNoSmallSteps-fNoInitialSmallSteps
-	 << "  "  << fNoBadSteps         
-	 << "   " << fDyerr_max
-	 << "   " << fDyerr_mx2 
-	 << "   " << fDyerrPos_smTot 
-	 << "   " << fSumH_sm
-	 << "   " << fDyerrPos_lgTot
-	 << "   " << fDyerrVel_lgTot
-	 << "   " << fSumH_lg
-	 << G4endl;
- #endif 
- #endif 
+         << "  "  << fNoBadSteps         
+         << "   " << fDyerr_max
+         << "   " << fDyerr_mx2 
+         << "   " << fDyerrPos_smTot 
+         << "   " << fSumH_sm
+         << "   " << fDyerrPos_lgTot
+         << "   " << fDyerrVel_lgTot
+         << "   " << fSumH_lg
+         << G4endl;
+#endif 
+#endif 
 
  G4cout.precision(oldPrec);
 }
  
+// ---------------------------------------------------------------------------
+
 void G4MagInt_Driver::SetSmallestFraction(G4double newFraction)
 {
-  if( (newFraction > 1.e-16) && (newFraction < 1e-8) ) {
-     fSmallestFraction= newFraction;
-  }else{ 
-     G4cerr << "Warning: SmallestFraction not changed. " << G4endl
-	    << "  Proposed value was " << newFraction << G4endl
-	    << "  Value must be between 1.e-8 and 1.e-16" << G4endl;
-  }
-}
+  if( (newFraction > 1.e-16) && (newFraction < 1e-8) )
+  {
+    fSmallestFraction= newFraction;
+  }
+  else
+  { 
+    G4cerr << "Warning: SmallestFraction not changed. " << G4endl
+           << "  Proposed value was " << newFraction << G4endl
+           << "  Value must be between 1.e-8 and 1.e-16" << G4endl;
+  }
+}
Index: trunk/source/geometry/magneticfield/src/G4MagIntegratorStepper.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4MagIntegratorStepper.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4MagIntegratorStepper.cc	(revision 1231)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4MagIntegratorStepper.cc,v 1.11 2006/06/29 18:24:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4MagIntegratorStepper.cc,v 1.12 2009/11/05 18:31:15 japost Exp $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
@@ -48,2 +48,7 @@
 {
 }
+
+void G4MagIntegratorStepper::ComputeRightHandSide( const G4double y[], G4double dydx[] ) 
+{
+  this->RightHandSide( y, dydx );
+}
Index: trunk/source/geometry/magneticfield/src/G4Mag_EqRhs.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4Mag_EqRhs.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4Mag_EqRhs.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_EqRhs.cc,v 1.11 2006/06/29 18:24:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //  This is the standard right-hand side for equation of motion  
Index: trunk/source/geometry/magneticfield/src/G4Mag_SpinEqRhs.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4Mag_SpinEqRhs.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4Mag_SpinEqRhs.cc	(revision 1231)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Mag_SpinEqRhs.cc,v 1.13 2008/11/21 21:18:26 gum Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4Mag_SpinEqRhs.cc,v 1.15 2009/03/25 15:29:02 gcosmo Exp $
+// GEANT4 tag $Name:  $
 //
 // This is the standard right-hand side for equation of motion.
@@ -48,5 +48,7 @@
 }
 
-G4Mag_SpinEqRhs::~G4Mag_SpinEqRhs() {}
+G4Mag_SpinEqRhs::~G4Mag_SpinEqRhs()
+{
+}
 
 void
@@ -70,6 +72,6 @@
 void
 G4Mag_SpinEqRhs::EvaluateRhsGivenB( const G4double y[],
-			            const G4double B[3],
-				    G4double dydx[] ) const
+                                    const G4double B[3],
+                                          G4double dydx[] ) const
 {
    G4double momentum_mag_square = sqr(y[3]) + sqr(y[4]) + sqr(y[5]);
@@ -97,6 +99,4 @@
    G4ThreeVector Spin(y[9],y[10],y[11]);
 
-   if (Spin.mag() > 0.) Spin = Spin.unit();
-
    G4ThreeVector dSpin;
 
Index: trunk/source/geometry/magneticfield/src/G4Mag_UsualEqRhs.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4Mag_UsualEqRhs.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4Mag_UsualEqRhs.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_UsualEqRhs.cc,v 1.12 2006/06/29 18:24:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
